<template>
    <div>
        <div
            class="font-black text-center capitalize text-lg pb-6"
        >
            {{ isOptIn ? $t('opt_out') : $t('opt_in') }}
        </div>
        <div
            class="pb-6 text-center"
        >
            {{ isOptIn ? optOutMessage : optInMessage }}
        </div>
        <div
            class="mb-4"
        >
            <div
                class="font-black text-left capitalize"
            >
                {{ $t('password2') }}
            </div>
            <form-pin
                v-model="password2"
                name="current_password2"
                hide-label
                dark
                fund
                :errors="errors && errors.current_password2 ? errors.current_password2 : null"
                size="lg"
            />
        </div>
        <div
            class="px-2"
        >
            <div
                class="cursor-pointer px-4 py-2 rounded-lg text-center w-full uppercase font-black tracking-wider text-lg"
                :class="{
                    'bg-red-500 text-white': isOptIn,
                    'bg-green-500 text-white': isOptOut,
                    'bg-opacity-50': busy
                }"
                @click="trySubmitForm"
            >
                {{ isOptIn ? $t('opt_out') : $t('opt_in') }}
            </div>
        </div>
    </div>
</template>

<script setup>
import {computed, ref} from "vue";
import {useI18n} from "vue-i18n";
import FormPin from "~/components/form/form-pin.vue";
import axios from "axios";

const props = defineProps({
    plan: {
        required: true,
        type: Object,
    },
    investment: {
        required: true,
        type: Object
    }
});
const emit = defineEmits(['close']);
const errors = ref([]);
const password2 = ref('');
const busy = ref(false);

const i18n = useI18n();

const isOptIn = computed(() => {
    return parseInt(props.investment.status) === 2 && parseInt(props.investment.opt_in) === 1;
});
const isOptOut = computed(() => {
    return !isOptIn.value;
});
const optInMessage = computed(() => {
    if (parseInt(props.investment.already_auto_opt_out) === 1) {
        return String(i18n.t('by_opt_in_after_auto_opt_out_hereby_agree'))
        return String(i18n.t('by_opt_in_hereby_agree'))
            .replace(/___FROM___/i, props.plan.setting.min_return_percentage_per_cycle + '%')
            .replace(/___TO___/i, props.plan.setting.max_return_percentage_per_cycle + '%');
    }
    return String(i18n.t('by_opt_in_hereby_agree'))
        .replace(/___FROM___/i, props.plan.setting.min_return_percentage_per_cycle + '%')
        .replace(/___TO___/i, props.plan.setting.max_return_percentage_per_cycle + '%');
});
const optOutMessage = computed(() => {
    return String(i18n.t('by_opt_out_hereby_agree'));
});
const trySubmitForm = async () => {
    if (!busy.value) {
        try {
            busy.value = true;
            errors.value = {};

            const data = await axios.post(`/portfolio/opt_${isOptIn.value ? 'out' : 'in'}/${props.investment.contract_id}`, {
                current_password2: password2.value
            });

            emit('close');
        } catch (e) {

        } finally {
            busy.value = false;
        }
    }
}
</script>
